<?php
/**
 * Created by PhpStorm.
 * User: sebastien
 * Date: 2018-12-13
 * Time: 15:32
 */

namespace WeLoveCustomers\Connector\Endpoint;


class BaseEndpoint
{

    private function getApiKey(){
        $objectManager =  \Magento\Framework\App\ObjectManager::getInstance();
        $apikey = $objectManager->get('Magento\Framework\App\Config\ScopeConfigInterface')->getValue('welovecustomersconnector/general/api_key');
        return $apikey;
    }

    private function getApiGlue(){
        $objectManager =  \Magento\Framework\App\ObjectManager::getInstance();
        $apiGlue = $objectManager->get('Magento\Framework\App\Config\ScopeConfigInterface')->getValue('welovecustomersconnector/general/api_glue');
        return $apiGlue;
    }


    public function getExtensionVersion()
    {
        $objectManager =  \Magento\Framework\App\ObjectManager::getInstance();
        $versionInfo =  $objectManager->get('Magento\Framework\Module\ModuleList')->getOne('WeLoveCustomers_Connector');
        $versionextension = $versionInfo[\WeLoveCustomers\Connector\Block\Adminhtml\System\Config\Versionnumber::VERSION_TAG];
        return $versionextension;

    }
    

    protected function doAuthRequest($serviceName, $params = array())
    {
        $authParams = array_merge(array(
            'customerKey' => $this->getApiKey(),
            'apiGlue' => $this->getApiGlue(),
        ), $params);

        return $this->callApi($serviceName, $authParams);
    }

    /**
     * @return string
     */
    public function getApiUrl(){
        return "https://pixel.welovecustomers.fr/api/";
    }

    /**
     * @param $service
     * @param $content
     */
    private function callApi($service, $content)
    {
        $content = http_build_query($content);

        $context_options = array(
            'http' => array(
                'method' => 'POST',
                'header' => "Content-type: application/x-www-form-urlencoded\r\n"
                    . "Content-Length: " . strlen($content) . "\r\n",
                'content' => $content
            )
        );

        $context = stream_context_create($context_options);
        $endPoint = $this->getApiUrl() . $service . "/";

        $fp = @fopen($endPoint, 'r', false, $context);
        $response = false;
        if ($fp) {
            while (($buffer = fgets($fp, 4096)) !== false) {
                $response .= $buffer;
            }
            if (!feof($fp)) {
            }
            fclose($fp);

        }

        return $response;

    }
}